diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-phy.cc ns-3.38/src/wifi/model/wifi-phy.cc
--- ns-3.37/src/wifi/model/wifi-phy.cc	2022-11-01 17:37:24.755396000 -0700
+++ ns-3.38/src/wifi/model/wifi-phy.cc	2023-03-16 20:54:23.868869300 -0700
@@ -364,6 +364,31 @@
 }
 
 void
+WifiPhy::DoInitialize()
+{
+    NS_LOG_FUNCTION(this);
+
+    // This method ensures that the local mobility model pointer holds
+    // a pointer to the Node's aggregated mobility model (if one exists)
+    // in the case that the user has not directly called SetMobility()
+    // on this WifiPhy during simulation setup.  If the mobility model
+    // needs to be added or changed during simulation runtime, users must
+    // call SetMobility() on this object.
+
+    if (!m_mobility)
+    {
+        NS_ABORT_MSG_UNLESS(m_device && m_device->GetNode(),
+                            "Either install a MobilityModel on this object or ensure that this "
+                            "object is part of a Node and NetDevice");
+        m_mobility = m_device->GetNode()->GetObject<MobilityModel>();
+        if (!m_mobility)
+        {
+            NS_LOG_WARN("Mobility not found, propagation models might not work properly");
+        }
+    }
+}
+
+void
 WifiPhy::DoDispose()
 {
     NS_LOG_FUNCTION(this);
@@ -592,14 +617,7 @@
 Ptr<MobilityModel>
 WifiPhy::GetMobility() const
 {
-    if (m_mobility)
-    {
-        return m_mobility;
-    }
-    else
-    {
-        return m_device->GetNode()->GetObject<MobilityModel>();
-    }
+    return m_mobility;
 }
 
 void
@@ -677,7 +695,8 @@
 WifiPhy::GetStaticPhyEntity(WifiModulationClass modulation)
 {
     const auto it = GetStaticPhyEntities().find(modulation);
-    NS_ABORT_MSG_IF(it == GetStaticPhyEntities().end(), "Unimplemented Wi-Fi modulation class");
+    NS_ABORT_MSG_IF(it == GetStaticPhyEntities().cend(),
+                    "Unimplemented Wi-Fi modulation class " << modulation);
     return it->second;
 }
 
@@ -685,7 +704,8 @@
 WifiPhy::GetPhyEntity(WifiModulationClass modulation) const
 {
     const auto it = m_phyEntities.find(modulation);
-    NS_ABORT_MSG_IF(it == m_phyEntities.end(), "Unsupported Wi-Fi modulation class " << modulation);
+    NS_ABORT_MSG_IF(it == m_phyEntities.cend(),
+                    "Unsupported Wi-Fi modulation class " << modulation);
     return it->second;
 }
 
@@ -695,6 +715,32 @@
     return GetPhyEntity(GetModulationClassForStandard(standard));
 }
 
+Ptr<PhyEntity>
+WifiPhy::GetLatestPhyEntity() const
+{
+    return GetPhyEntity(m_standard);
+}
+
+Ptr<PhyEntity>
+WifiPhy::GetPhyEntityForPpdu(const Ptr<const WifiPpdu> ppdu) const
+{
+    NS_ABORT_IF(!ppdu);
+    const auto modulation = ppdu->GetModulation();
+    if (modulation > m_phyEntities.rbegin()->first)
+    {
+        // unsupported modulation: start reception process with latest PHY entity
+        return GetLatestPhyEntity();
+    }
+    if (modulation < WIFI_MOD_CLASS_HT)
+    {
+        // for non-HT (duplicate), call the latest PHY entity since some extra processing can be
+        // done in PHYs implemented in HT and later (e.g. channel width selection for non-HT
+        // duplicates)
+        return GetLatestPhyEntity();
+    }
+    return GetPhyEntity(modulation);
+}
+
 void
 WifiPhy::AddStaticPhyEntity(WifiModulationClass modulation, Ptr<PhyEntity> phyEntity)
 {
@@ -1000,6 +1046,18 @@
     return m_fixedPhyBand;
 }
 
+uint16_t
+WifiPhy::GetTxBandwidth(WifiMode mode, uint16_t maxAllowedWidth) const
+{
+    auto modulation = mode.GetModulationClass();
+    if (modulation == WIFI_MOD_CLASS_DSSS || modulation == WIFI_MOD_CLASS_HR_DSSS)
+    {
+        return 22;
+    }
+
+    return std::min({GetChannelWidth(), GetMaximumChannelWidth(modulation), maxAllowedWidth});
+}
+
 void
 WifiPhy::SetOperatingChannel(const ChannelTuple& channelTuple)
 {
@@ -1727,7 +1785,8 @@
     m_endTxEvent =
         Simulator::Schedule(txDuration, &WifiPhy::NotifyTxEnd, this, psdus); // TODO: fix for MU
 
-    StartTx(ppdu, txVector);
+    StartTx(ppdu);
+    ppdu->ResetTxVector();
 
     m_channelAccessRequested = false;
     m_powerRestricted = false;
@@ -1759,7 +1818,8 @@
                               RxPowerWattPerChannelBand& rxPowersW,
                               Time rxDuration)
 {
-    WifiModulationClass modulation = ppdu->GetTxVector().GetModulationClass();
+    NS_LOG_FUNCTION(this << ppdu << rxDuration);
+    WifiModulationClass modulation = ppdu->GetModulation();
     auto it = m_phyEntities.find(modulation);
     if (it != m_phyEntities.end())
     {
@@ -1998,14 +2058,14 @@
 WifiPhy::SwitchMaybeToCcaBusy(const Ptr<const WifiPpdu> ppdu)
 {
     NS_LOG_FUNCTION(this);
-    GetPhyEntity(m_standard)->SwitchMaybeToCcaBusy(ppdu);
+    GetLatestPhyEntity()->SwitchMaybeToCcaBusy(ppdu);
 }
 
 void
 WifiPhy::NotifyCcaBusy(const Ptr<const WifiPpdu> ppdu, Time duration)
 {
     NS_LOG_FUNCTION(this << duration);
-    GetPhyEntity(m_standard)->NotifyCcaBusy(ppdu, duration, WIFI_CHANLIST_PRIMARY);
+    GetLatestPhyEntity()->NotifyCcaBusy(ppdu, duration, WIFI_CHANLIST_PRIMARY);
 }
 
 void
@@ -2072,7 +2132,7 @@
 WifiPhy::GetTxPowerForTransmission(Ptr<const WifiPpdu> ppdu) const
 {
     NS_LOG_FUNCTION(this << m_powerRestricted << ppdu);
-    const WifiTxVector& txVector = ppdu->GetTxVector();
+    const auto& txVector = ppdu->GetTxVector();
     // Get transmit power before antenna gain
     double txPowerDbm;
     if (!m_powerRestricted)
@@ -2108,7 +2168,7 @@
 WifiPhy::GetAddressedPsduInPpdu(Ptr<const WifiPpdu> ppdu) const
 {
     // TODO: wrapper. See if still needed
-    return GetPhyEntity(ppdu->GetModulation())->GetAddressedPsduInPpdu(ppdu);
+    return GetPhyEntityForPpdu(ppdu)->GetAddressedPsduInPpdu(ppdu);
 }
 
 WifiSpectrumBand
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-phy-common.cc ns-3.38/src/wifi/model/wifi-phy-common.cc
--- ns-3.37/src/wifi/model/wifi-phy-common.cc	2022-11-01 17:37:24.755396000 -0700
+++ ns-3.38/src/wifi/model/wifi-phy-common.cc	2023-03-16 20:54:23.868869300 -0700
@@ -70,38 +70,6 @@
     return gi;
 }
 
-uint16_t
-GetChannelWidthForTransmission(WifiMode mode, uint16_t maxAllowedChannelWidth)
-{
-    WifiModulationClass modulationClass = mode.GetModulationClass();
-    if (maxAllowedChannelWidth > 20 &&
-        (modulationClass == WifiModulationClass::WIFI_MOD_CLASS_OFDM // all non-HT OFDM control and
-                                                                     // management frames
-         || modulationClass ==
-                WifiModulationClass::WIFI_MOD_CLASS_ERP_OFDM)) // special case of beacons at 2.4 GHz
-    {
-        return 20;
-    }
-    // at 2.4 GHz basic rate can be non-ERP DSSS
-    if (modulationClass == WifiModulationClass::WIFI_MOD_CLASS_DSSS ||
-        modulationClass == WifiModulationClass::WIFI_MOD_CLASS_HR_DSSS)
-    {
-        return 22;
-    }
-    return maxAllowedChannelWidth;
-}
-
-uint16_t
-GetChannelWidthForTransmission(WifiMode mode,
-                               uint16_t operatingChannelWidth,
-                               uint16_t maxSupportedChannelWidth)
-{
-    return GetChannelWidthForTransmission(mode,
-                                          (operatingChannelWidth < maxSupportedChannelWidth)
-                                              ? operatingChannelWidth
-                                              : maxSupportedChannelWidth);
-}
-
 WifiPreamble
 GetPreambleForTransmission(WifiModulationClass modulation, bool useShortPreamble)
 {
@@ -145,6 +113,30 @@
     }
 }
 
+WifiModulationClass
+GetModulationClassForPreamble(WifiPreamble preamble)
+{
+    switch (preamble)
+    {
+    case WIFI_PREAMBLE_HT_MF:
+        return WIFI_MOD_CLASS_HT;
+    case WIFI_PREAMBLE_VHT_SU:
+    case WIFI_PREAMBLE_VHT_MU:
+        return WIFI_MOD_CLASS_VHT;
+    case WIFI_PREAMBLE_HE_SU:
+    case WIFI_PREAMBLE_HE_ER_SU:
+    case WIFI_PREAMBLE_HE_MU:
+    case WIFI_PREAMBLE_HE_TB:
+        return WIFI_MOD_CLASS_HE;
+    case WIFI_PREAMBLE_EHT_MU:
+    case WIFI_PREAMBLE_EHT_TB:
+        return WIFI_MOD_CLASS_EHT;
+    default:
+        NS_ABORT_MSG("Unsupported preamble type: " << preamble);
+    }
+    return WIFI_MOD_CLASS_UNKNOWN;
+}
+
 bool
 IsAllowedControlAnswerModulationClass(WifiModulationClass modClassReq,
                                       WifiModulationClass modClassAnswer)
@@ -252,4 +244,34 @@
     return modulationClass;
 }
 
+uint16_t
+GetMaximumChannelWidth(WifiModulationClass modulation)
+{
+    switch (modulation)
+    {
+    case WIFI_MOD_CLASS_DSSS:
+    case WIFI_MOD_CLASS_HR_DSSS:
+        return 22;
+    case WIFI_MOD_CLASS_OFDM:
+    case WIFI_MOD_CLASS_ERP_OFDM:
+        return 20;
+    case WIFI_MOD_CLASS_HT:
+        return 40;
+    case WIFI_MOD_CLASS_VHT:
+    case WIFI_MOD_CLASS_HE:
+        return 160;
+    case WIFI_MOD_CLASS_EHT:
+        return 160; // TODO update when 320 MHz channels are supported
+    default:
+        NS_ABORT_MSG("Unknown modulation class: " << modulation);
+        return 0;
+    }
+}
+
+bool
+IsEht(WifiPreamble preamble)
+{
+    return ((preamble == WIFI_PREAMBLE_EHT_MU) || (preamble == WIFI_PREAMBLE_EHT_TB));
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-phy-common.h ns-3.38/src/wifi/model/wifi-phy-common.h
--- ns-3.37/src/wifi/model/wifi-phy-common.h	2022-11-01 17:37:24.755396000 -0700
+++ ns-3.38/src/wifi/model/wifi-phy-common.h	2023-03-16 20:54:23.868869300 -0700
@@ -476,29 +476,13 @@
 WifiPreamble GetPreambleForTransmission(WifiModulationClass modulation, bool useShortPreamble);
 
 /**
- * Return the channel width that is allowed based on the selected mode and the given
- * maximum channel width. This is especially useful when using non-HT modes with
- * HT/VHT/HE capable stations (with default width above 20 MHz).
- *
- * \param mode selected WifiMode
- * \param maxAllowedChannelWidth maximum channel width allowed for the transmission
- * \return channel width adapted to the selected mode
- */
-uint16_t GetChannelWidthForTransmission(WifiMode mode, uint16_t maxAllowedChannelWidth);
-/**
- * Return the channel width that is allowed based on the selected mode, the current
- * width of the operating channel and the maximum channel width supported by the
- * receiver. This is especially useful when using non-HT modes with HT/VHT/HE
- * capable stations (with default width above 20 MHz).
- *
- * \param mode selected WifiMode
- * \param operatingChannelWidth operating channel width
- * \param maxSupportedChannelWidth maximum channel width supported by the receiver
- * \return channel width adapted to the selected mode
- */
-uint16_t GetChannelWidthForTransmission(WifiMode mode,
-                                        uint16_t operatingChannelWidth,
-                                        uint16_t maxSupportedChannelWidth);
+ * Return the modulation class corresponding to the given preamble type.
+ * Only preamble types used by HT/VHT/HE/EHT can be passed to this function.
+ *
+ * \param preamble the given preamble type (must be one defined by HT standard or later)
+ * \return the modulation class corresponding to the given preamble type
+ */
+WifiModulationClass GetModulationClassForPreamble(WifiPreamble preamble);
 
 /**
  * Return whether the modulation class of the selected mode for the
@@ -556,6 +540,22 @@
  */
 WifiModulationClass GetModulationClassForStandard(WifiStandard standard);
 
+/**
+ * Get the maximum channel width in MHz allowed for the given modulation class.
+ *
+ * \param modulation the modulation class
+ * \return the maximum channel width in MHz allowed for the given modulation class
+ */
+uint16_t GetMaximumChannelWidth(WifiModulationClass modulation);
+
+/**
+ * Return true if a preamble corresponds to an EHT transmission.
+ *
+ * \param preamble the preamble
+ * \return true if the provided preamble corresponds to an EHT transmission
+ */
+bool IsEht(WifiPreamble preamble);
+
 } // namespace ns3
 
 #endif /* WIFI_PHY_COMMON_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-phy.h ns-3.38/src/wifi/model/wifi-phy.h
--- ns-3.37/src/wifi/model/wifi-phy.h	2022-11-01 17:37:24.755396000 -0700
+++ ns-3.38/src/wifi/model/wifi-phy.h	2023-03-16 20:54:23.868869300 -0700
@@ -28,6 +28,8 @@
 
 #include "ns3/error-model.h"
 
+#include <limits>
+
 namespace ns3
 {
 
@@ -151,9 +153,8 @@
 
     /**
      * \param ppdu the PPDU to send
-     * \param txVector the TXVECTOR to use to send the PPDU
      */
-    virtual void StartTx(Ptr<const WifiPpdu> ppdu, const WifiTxVector& txVector) = 0;
+    virtual void StartTx(Ptr<const WifiPpdu> ppdu) = 0;
 
     /**
      * Put in sleep mode.
@@ -898,6 +899,18 @@
      */
     uint8_t GetPrimary20Index() const;
     /**
+     * Get the bandwidth for a transmission occurring on the current operating channel and
+     * using the given WifiMode, subject to the constraint that the TX bandwidth cannot exceed
+     * the given maximum allowed value.
+     *
+     * \param mode the given WifiMode
+     * \param maxAllowedBandWidth the maximum allowed TX bandwidth
+     * \return the bandwidth for the transmission
+     */
+    uint16_t GetTxBandwidth(
+        WifiMode mode,
+        uint16_t maxAllowedBandWidth = std::numeric_limits<uint16_t>::max()) const;
+    /**
      * \param antennas the number of antennas on this node.
      */
     void SetNumberOfAntennas(uint8_t antennas);
@@ -1058,6 +1071,19 @@
     static const Ptr<const PhyEntity> GetStaticPhyEntity(WifiModulationClass modulation);
 
     /**
+     * Get the supported PHY entity to use for a received PPDU.
+     * This typically returns the entity corresponding to the modulation class used to transmit the
+     * PPDU. If the modulation class used to transmit the PPDU is not supported by the PHY, the
+     * latest PHY entity corresponding to the configured standard is returned. If the modulation
+     * used to transmit the PPDU is non-HT (duplicate), the latest PHY entity corresponding to the
+     * configured standard is also returned.
+     *
+     * \param ppdu the received PPDU
+     * \return the pointer to the supported PHY entity
+     */
+    Ptr<PhyEntity> GetPhyEntityForPpdu(const Ptr<const WifiPpdu> ppdu) const;
+
+    /**
      * Get the supported PHY entity corresponding to the modulation class.
      *
      * \param modulation the modulation class
@@ -1071,6 +1097,12 @@
      * \return the pointer to the supported PHY entity
      */
     Ptr<PhyEntity> GetPhyEntity(WifiStandard standard) const;
+    /**
+     * Get the latest PHY entity supported by this PHY instance.
+     *
+     * \return the latest PHY entity supported by this PHY instance
+     */
+    Ptr<PhyEntity> GetLatestPhyEntity() const;
 
     /**
      * \return the UID of the previously received PPDU (reset to UINT64_MAX upon transmission)
@@ -1120,6 +1152,7 @@
     virtual WifiSpectrumBand GetBand(uint16_t bandWidth, uint8_t bandIndex = 0);
 
   protected:
+    void DoInitialize() override;
     void DoDispose() override;
 
     /**
